package;

import luxe.States;
import luxe.Entity;
import luxe.Vector;
import luxe.Color;
import luxe.Visual;
import luxe.Sprite;
import luxe.Rectangle;
import luxe.Text;
import luxe.Input;

class PlayState extends State {

	public function new(_name:String) {

		super({ name: _name });

		Main.world = new World();

	} //new


	override function init() {

		trace('* PlayState init');

	} //init


	override function onenter<T>(_value:T) {

		trace('* PlayState Start');

		Main.player = new Player();

		new Skeleton();

	}


	override function onleave<T>(_value:T) {

		trace('* PlayState End');

		Main.player.destroy();
		Main.world.destroy();

	}

	override function onkeyup( e:KeyEvent ) {

		if (e.keycode == Key.key_1) {
			Luxe.timescale = 1;
		}

		if (e.keycode == Key.key_2) {
			trace('* SPEED 2');
			Luxe.timescale = 2;
		}

		if (e.keycode == Key.key_3) {
			Luxe.timescale = 3;
		}

	} //onkeyup

}