package;

import luxe.Color;
import luxe.Entity;
import luxe.Text;
import luxe.Sprite;
import luxe.Vector;
import luxe.tween.Actuate;

import phoenix.Batcher;

/**
 * ...
 * @author DevZero
 */
class Progress extends Entity {
	
	var front		: Sprite;
	var back 		: Sprite;
	
    var sx 			: Int 			= 28;
    var sy 			: Int 			= 10;
	
	var color 		: Color;

	var _batcher 	: Batcher;
	
	public function new( _color : Color ) {
		
		color 	= _color;
		
		super({
			name: 'Progress',
			name_unique: true,
			pos: new Vector(0,0)
		});
		// trace("* new Progress");
		
	}
	
	// Init
	override function init() {
        // trace('* Progress Init');
		
		back = new Sprite({
			name: 'progress.Back',
			name_unique: true,

			pos: new Vector(0,0), 		// Entity controls pos
			size: new Vector( sx, sy ),
			centered: true,
			// texture: Luxe.resources.texture( 'assets/texture/blank.png' ),
			color: new Color().rgb(0x333333),
			depth: 10
		});
		
		front = new Sprite({
			name: 'progress.Front',
			name_unique: true,

			pos: new Vector(2,2),		// Pos offset
			size: new Vector( sx - 4, sy - 4),
			centered: false,
			// texture: Luxe.resources.texture( 'assets/texture/blank.png' ),
			color: color,
			depth: 10,
		});
		
		back.color.a 	= 0.6;
		front.color.a 	= 0.9;

		back.parent = this;
		front.parent = back;
	}

	
	// Set progress percent
	public function setPercent( _percent : Float ) {
		
		if (front != null) {
			Actuate.tween( front.size, 0.3, { x: (sx - 2) * _percent })
				.ease( luxe.tween.easing.Cubic.easeInOut );
		}
		
	}
	

	override function ondestroy() {
		back.destroy();
		front.destroy();

		super.ondestroy();
	}
	
	
	
}