package;

/**
 * ...
 * @author DevZero
 */

import luxe.Component;
import luxe.Vector;
import luxe.Color;
import luxe.Visual;
import luxe.Text;
import luxe.tween.Actuate;

class TextBubble extends Component {

	public var duration 	: Float = 1;
	public var moveX 		: Float = 260;
	public var moveY 		: Float = 180;

	var _visual 			: Visual;
	var _text 				: Text;
	var _currVal 			: String = '';

	public function new( _duration : Float = 1.6 ) {

		super({ name: 'TextBubble' });

		duration = _duration;
	}


	override function init() {

		_visual = cast entity;

		_text = new Text({
			name: 'textBubbleText',
			pos: new Vector(_visual.size.x / 2, 0),
			text: '0123',
			point_size: 16,
			color: new Color().rgb(0xFFFFFF),
			depth: 10,
			align: center,
			align_vertical: bottom,
			parent: entity
		});
		
		// Tween up
		/*
		Actuate.tween( _visual.pos, duration * 0.3, {
			y : _visual.pos.y - moveY
		})
		.ease( luxe.tween.easing.Quad.easeOut )
		.onComplete(function() {

			// Tween back down with bounce
			Actuate.tween( _visual.pos, duration * 0.6, {
				y : _visual.pos.y + moveY
			})
			.ease( luxe.tween.easing.Bounce.easeOut );

		});

		// Tween left/right
		Actuate.tween( _visual.pos, duration, {
			x : _visual.pos.x + moveX
		})
		.ease( luxe.tween.easing.Quad.easeInOut )
		.onComplete(function() {
			_visual.destroy();
		});
		*/
	}

	override function update( dt : Float) {
		if (_text != null && _text.text != _currVal) {
			_text.text = _currVal;
		}
	}

	public function setValue( inVal : String ) {
		_currVal = inVal;
	}


	override function ondestroy() {
		_text.destroy();

		super.ondestroy();
	}


}