package;

import luxe.Entity;
import luxe.Sprite;
import luxe.Vector;
import luxe.Color;
import luxe.tween.Actuate;
import luxe.Particles;

import luxe.components.sprite.SpriteAnimation;

import snow.api.Timer;

import phoenix.Texture.FilterType;

/**
 * Town object, holds sprite and props
 * @author DevZero
 */
class Town extends Sprite {

	public var population 	: Float = 1;

	var _bubble 			: TextBubble;

	var anim 				: SpriteAnimation;

	var updateTimer 		: Timer;

	// Instantiation
	public function new() {

		trace("* new Town");

		// Give player a visual
		super({
			name: 'town',
			name_unique: true,
			pos: new Vector(420, 420),
			size: new Vector(64, 56),
			texture: Luxe.resources.texture('assets/sprites/Town.png'),
			depth: 1
		});

		// _bubble = new TextBubble();

		initSprite();

	}

	
	// Init
	override function init() {

		trace('* Town Init');
		// add( _bubble );

		tick();
		updateTimer = Luxe.timer.schedule( 9, tick, true );

	}



	public function tick() {

		if (Main.world.towns.length < 2) {
			trace('* T - No (other) towns left! Skipping tick'); return;
		}

		// Send out a person
		var targetTown : Town = Main.world.towns[ Main.rng.int(0, Main.world.towns.length) ];

		if (targetTown == null || targetTown == this) { tick(); return; }

		var aPerson : Person = new Person();
		aPerson.pos = pos.clone();
		aPerson.moveTo( targetTown, true );
		Main.world.persons.push( aPerson );
	}


	public function setPopulation( inVal : Float ) {
		population = inVal;

		if (_bubble != null) {
			_bubble.setValue( '' + Math.round( population ) );
		}
	}


	public function incrPopulation( inVal : Float ) {
		setPopulation( population + inVal );
	}

	
	override function ondestroy() {

		updateTimer.stop();

		super.ondestroy();
	}


	function initSprite() {

		/*
		anim = new SpriteAnimation({ name: 'townanim' });
		add(anim);

		
		var animation_json = '
			{
				"idle" : {
					"frame_size":{ "x":"30", "y":"38" },
					"frameset": ["1-6"],
					"events" : [],
					"pingpong": "true",
					"loop": "true",
					"speed": "10"
				},
				"walk" : {
					"frame_size":{ "x":"34", "y":"36" },
					"frameset": ["1-12"],
					"events" : [{"frame":8, "event":"foot.1"}, {"frame":1, "event":"foot.2"}, { "frame": 6 }],
					"pingpong":"false",
					"loop": "true",
					"speed": "18"
				},
				"walk_glitch" : {
					"frame_sources":[{
						"frame":8, "x":0, "y":0, "w":96, "h":96
					}],
					"frame_size":{ "x":"48", "y":"48" },
					"frameset": ["1-8","9","10","hold 10","11 hold 5", "12"],
					"pingpong":"false",
					"loop": "true",
					"speed": "18"
				}
			}
		';

		anim.add_from_json( animation_json );

		anim.animation = 'idle';
		anim.play();
		*/

		// Do thing on sprite anim events
		/*sprite.events.listen('foot.1', function(e){
            Luxe.audio.play('step1'); //:todo:
        });
		*/


	}

}